



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python读取yaml配置文件</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python读取yaml配置文件</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 01:29:17 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>支持多种语言：python、js、golang、java、c、c++</p>
<p>YAML 语言（发音 /ˈj&aelig;məl/ ）的设计目标，就是方便人类读写。它实质上是一种通用的数据串行化格式。</p>
<p>它的基本语法规则如下。</p>
<blockquote><ul><li>大小写敏感</li>
<li>使用缩进表示层级关系</li>
<li>缩进时不允许使用Tab键，只允许使用空格。</li>
<li>缩进的空格数目不重要，只要相同层级的元素左侧对齐即可</li></ul></blockquote>
<p><code>#</code> 表示注释，从这个字符一直到行尾，都会被解析器忽略。</p>
<p>YAML 支持的数据结构有三种。</p>
<blockquote><ul><li>对象：键值对的集合，又称为映射（mapping）/ 哈希（hashes） / 字典（dictionary）</li>
<li>数组：一组按次序排列的值，又称为序列（sequence） / 列表（list）</li>
<li>纯量（scalars）：单个的、不可再分的值</li></ul></blockquote>
<h4>安装插件：</h4>
<p>pip install pyyaml</p>
<p>PyYAML文档：https://pyyaml.org/</p>
<p>https://pyyaml.org/wiki/PyYAMLDocumentation</p>
<h4>yaml配置文件结构</h4>
<p>网上搜搜吧，很多</p>
<h4>python操作yaml文件：</h4>
<p>https://www.cnblogs.com/BlueSkyyj/p/8143826.html</p>
<p>读取配置：</p>
<div>
<pre class="prettyprint linenums">import yaml<br />
import os

# 获取当前文件路径 D:/WorkSpace/StudyPractice/Python_Yaml/YamlStudy<br />
filePath = os.path.dirname(__file__)<br />
print(filePath)<br />
# 获取当前文件的Realpath  D:\WorkSpace\StudyPractice\Python_Yaml\YamlStudy\YamlDemo.py<br />
fileNamePath = os.path.split(os.path.realpath(__file__))[]<br />
print(fileNamePath)<br />
# 获取配置文件的路径 D:/WorkSpace/StudyPractice/Python_Yaml/YamlStudy\config.yaml<br />
yamlPath = os.path.join(fileNamePath,'config.yaml')<br />
print(yamlPath)<br />
# 加上 ,encoding='utf-8'，处理配置文件中含中文出现乱码的情况。<br />
f = open(yamlPath,'r',encoding='utf-8')

cont = f.read()

x = yaml.load(cont)<br />
print(type(x))<br />
print(x)<br />
print(x['EMAIL'])<br />
print(type(x['EMAIL']))<br />
print(x['EMAIL']['Smtp_Server'])<br />
print(type(x['EMAIL']['Smtp_Server']))<br />
print(x['DB'])<br />
print(x['DB']['host'])

print(x.get('DB').get('host'))

print(type(x.get('DB')))</pre>
</div>
<p>写入配置</p>
<div>
<pre class="prettyprint linenums"># 写入yaml 文件<br />
# a 追加写入，w,覆盖写入<br />
fw = open(yamlPath,'a',encoding='utf-8')<br />
# 构建数据<br />
data = {"cookie1":{'domain': '.yiyao.cc', 'expiry': 1521558688.480118, 'httpOnly': False, 'name': '_ui_', 'path': '/', 'secure': False, 'value': 'HSX9fJjjCIImOJoPUkv/QA=='}}<br />
# 装载数据<br />
yaml.dump(data,fw)<br />
# 读取数据，获取文件<br />
f = open(yamlPath,'r',encoding='utf-8')<br />
# 读取文件<br />
cont = f.read()<br />
# 加载数据<br />
x = yaml.load(cont)<br />
# 打印数据<br />
print(x)<br />
# 打印读取写入的数据<br />
print(x.get("cookie1"))</pre>
</div>
<h4>参考：</h4>
<p>https://yaml.org/</p>
<p>http://www.ruanyifeng.com/blog/2016/07/yaml.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqv11poq.html">项目vue2&period;0仿外卖APP（四）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mevv0q.html">动态更换应用Icon</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzgmpq.html">js创建和获取cookie</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r24ddq.html">APK Downgrade Method working fine on LINE latest version 6&period;7&period;1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdvmjy8.html">Delphi调用外部程序函数：WinExec&lpar;&rpar; 和ShellExecute详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdn55m8.html">关于&amp;lt&semi;html&amp;gt&semi;标签里的class&equals; no-js</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zj3ez9.html">《RHEL6&period;3权限的管理》</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wgv13q.html">L005-oldboy-mysql-dba-lesson05</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1pl0v9.html">c语言学习之基础知识点介绍（十）：内存空间模型、地址解释及指针变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1gyo39.html">《C&num; 并发编程 &amp;&num;183&semi; 经典实例》读书笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z54oe9.html">codeforce round &num;467&lpar;div&period;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvj7p38.html">homework1-201521410029</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jx12q.html">python3编写网络爬虫21-scrapy框架的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9603w339.html">字符串相关的hash值（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1v61xq.html">Loadrunner 如何在其他浏览器进行录制（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o15m0lq.html">jquery&vert;js&vert;jq常用正则</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1xvve9.html">Python 字符编码简记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyp3wv9.html">Qt开发的程序在没有安装Qt环境的机器上可能出现的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw4e409.html">AutoMapper&period;Mapper&period;CreateMap报&OpenCurlyDoubleQuote;System&period;NullReferenceException&colon; 未将对象引用设置到对象的实例。&rdquo;异常复现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx4228.html">spring ----&amp;gt&semi; 搭建spring&plus;springmvc&plus;mybatis出现的几个问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9gpmwn49.html">ref&colon;linux用户和组管理，&sol;etc&sol;passwd&comma;&sol;etc&sol;shadow和&sol;etc&sol;group 文件内容解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm03yw9.html">配置SSH服务使用证书登录Ubuntu服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7em6xg9.html">聊聊zookeeper的分布式锁</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2np608.html">InnoDB的锁机制浅析&lpar;一&rpar;&mdash;基本概念&sol;兼容矩阵</a>
			</li>
						<li><a href="https://www.batexi.com/a/963oxwy9.html">odoo权限管理（二&period;记录管理）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rndej7q.html">html （第四本书第1~3章参考）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwld70r9.html">BZOJ 4198&colon; &lbrack;Noi2015&rsqb;荷马史诗 哈夫曼树 k叉哈夫曼树</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnn1rwjq.html">五校联考R1 Day2T2 矩阵matrix&lpar;容斥&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko1366q.html">python3 开发面试题（collections中的Counter）6&period;7</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zko13x8.html">j&period;u&period;c系列（09）---之并发工具类：CyclicBarrier</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
